from config import *

# Support Chinese ID
from OFS import ObjectManager
import re
ObjectManager.bad_id=re.compile(r'[^a-zA-Z0-9-_~,.$\(\)# ]%').search #TS 

# DateTime, cst
# from DateTime import DateTime
# DateTime._cache._zmap.update({'cst':'GMT+8'})

# pak to support Chinese when using ut8 as default encoding
# pak FTPRequest.py def _get_env here for chinese supporting;
from ZServer.FTPRequest import FTPRequest
from ZServer.FTPServer import FTPServer

original_get_env = FTPRequest._get_env

def _get_env(self, path, command, channel, stdin):
    path = unicode(path, FTP_CLIENT_ENCODING).encode('utf8')
    if type(command)==type(()):
        command = tuple([unicode(arg, FTP_CLIENT_ENCODING).encode('utf8') for arg in command])
    return original_get_env(self, path, command, channel, stdin)

FTPRequest._get_env = _get_env

def listdir_completion(self, long, response):
        status=response.getStatus()
        if status==200:
            if self.anonymous and not self.userid=='anonymous':
                self.anonymous=None
            dir_list=''
            file_infos=response._marshalledBody()
            if type(file_infos[0])==type(''):
                file_infos=(file_infos,)
            if long:
                for id, stat_info in file_infos:
                    id = unicode(id, 'utf8').encode(FTP_CLIENT_ENCODING) # pak here
                    dir_list=dir_list+filesys.unix_longify(id,stat_info)+'\r\n'
            else:
                for id, stat_info in file_infos:
                    id = unicode(id, 'utf8').encode(FTP_CLIENT_ENCODING) # pak here
                    dir_list=dir_list+id+'\r\n'
            self.make_xmit_channel()
            self.client_dc.push(dir_list)
            self.client_dc.close_when_done()
            self.respond(
                '150 Opening %s mode data connection for file list' % (
                    self.type_map[self.current_mode]
                    )
                )
        elif status in (401, 403):
            self.respond('530 Unauthorized.')
        else:
            self.respond('550 Could not list directory.')

FTPServer.listdir_completion = listdir_completion
